import java.util.Properties
import org.jetbrains.kotlin.gradle.dsl.KotlinVersion
import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.defineXomrkGiteaMavenRepo
import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.forceSetAllMavenArtifactsId
import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.optInContracts
import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.setCompatibilityWithKotlin

buildscript {
	val versions = java.util.Properties()
	versions.load(rootDir.resolve("../versions.properties").inputStream())


	dependencies {
		classpath("ru.landgrafhomyak.kotlin:kotlin-mpp-gradle-build-helper:v${versions.getProperty("this")}k${versions.getProperty("kotlin")}")
	}
}

plugins {
	kotlin("multiplatform") version "2.0.20"
	`maven-publish`
}

val versions = Properties()
versions.load(rootDir.resolve("../versions.properties").inputStream())

val targetKotlinVersion = versions.getProperty("kotlin")

group = "ru.landgrafhomyak.kotlin"
version = "v${versions.getProperty("this")}k${targetKotlinVersion}"

repositories {
	mavenCentral()
}



kotlin {
	optInContracts()

	jvmToolchain(8)
	jvm()
	setCompatibilityWithKotlin(KotlinVersion.KOTLIN_1_8)

	sourceSets {
		jvmMain {
			dependencies {
				compileOnly("dev.gradleplugins:gradle-api:${versions.getProperty("gradle")}")
				api("${group}:kotlin-mpp-gradle-build-helper:${version}")
				api("org.jetbrains.kotlin:kotlin-gradle-plugin:${targetKotlinVersion}")
			}
		}
	}
}

publishing {
	repositories {
		defineXomrkGiteaMavenRepo()
	}

	forceSetAllMavenArtifactsId(project.name)
}