package ru.landgrafhomyak.kotlin.kmp_gradle_build_helper

import org.gradle.api.publish.PublishingExtension
import org.gradle.api.publish.maven.MavenPublication

public fun PublishingExtension.forceSetAllMavenArtifactsId(newName: String) {
	this.publications { c ->
		c.withType(MavenPublication::class.java) { p ->
			p.artifactId = newName
		}
	}
}

public fun PublishingExtension.replaceAllMavenArtifactsIdPrefixes(oldPrefix: String, newPrefix: String) {
	val pattern = Regex("^${Regex.escape(oldPrefix)}")
	this.publications { c ->
		c.withType(MavenPublication::class.java) { p ->
			p.artifactId = p.artifactId.replace(pattern, newPrefix)
		}
	}
}

public fun PublishingExtension.replaceAllMavenArtifactsIdSuffixes(oldSuffix: String, newSuffix: String) {
	val pattern = Regex("${Regex.escape(oldSuffix)}$")
	this.publications { c ->
		c.withType(MavenPublication::class.java) { p ->
			p.artifactId = p.artifactId.replace(pattern, newSuffix)
		}
	}
}